#include <test/lib/test/PAliasInterpreterTest.h>

// Auto generated Tests from PAliasInterpreterTest

// Test Object to put test methods into 
Type_Class AutoGenTest_TestCase_Class;
Object AutoGenTest_test_Class_Instance;
// Test Method symbol 
Type_Symbol PAliasInterpreterTest_SMB_runTestCase;


/* ========================================================================= */

NEW_TEST(PAliasInterpreterTest_testConstant)
/*
testConstant
// 	| result |
// 	result := PAliasInterpreter interpret: [ 2 ].
// 	
// 	result should beKindOf: PReturnAlias.
// 	result value should be: 2.
// 	
// 	result := result origin.
// 	result should beKindOf: PLiteralAlias.
// 	result origin should be: nil.
// 	result value should be: 2.
*/
Object symbol7240 = (Object)new_Type_Symbol_cached(L"testConstant");
// testConstant. 
Object send41132 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7240, 0);
Eval((Object)send41132);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PAliasInterpreterTest_testFieldWriteTest)
/*
testFieldWriteTest
// 	| result |
// 	result := PAliasInterpreter interpret: [ |c|
// 		c := ChildClassTestClass new.
// 		c a: 10.
// 		c
// 	].
// 
// 	result should beKindOf: PReturnAlias.
// 	result value should beKindOf: ChildClassTestClass.
// 	result context should beKindOf: PBlockContext.
// 	result context homeContext closure selector should be: #testFieldWriteTest.
// 	
// 	result := result value.
// 	result a should beKindOf: PFieldWriteAlias.
// 	result b should beKindOf: PAllocationAlias.
// 	
// 	result := result a.
// 	result value should be: 10.
// 
// 	result predecessor should beKindOf: PAllocationAlias.
// 	
// 	result := result origin.
// 	result should beKindOf: PParameterAlias.
// 	result value should be: 10.
// 	
// 	result := result origin.
// 	result should beKindOf: PLiteralAlias.
// 	result value should be: 10.
// 	result origin should be: nil.
*/
Object symbol7244 = (Object)new_Type_Symbol_cached(L"testFieldWriteTest");
// testFieldWriteTest. 
Object send41133 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7244, 0);
Eval((Object)send41133);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PAliasInterpreterTest_testInstanceCreation)
/*
testInstanceCreation
// 	| result |
// 	result := PAliasInterpreter interpret: [
// 		ChildClassTestClass new.
// 	].
// 
// 	result should beKindOf: PReturnAlias.
// 	result value should beKindOf: ChildClassTestClass.
// 	result context should beKindOf: PBlockContext.
// 	result context homeContext closure selector should be: #testInstanceCreation.
// 	
// 	result := result origin.
// 	result should beKindOf: PReturnAlias.
// 	result value should beKindOf: ChildClassTestClass.
// 	result context should beKindOf: PMethodContext.
// 	result context homeContext closure selector should be: #new.
// 	
// 	result := result origin.
// 	result should beKindOf: PReturnAlias.
// 	result value should beKindOf: ChildClassTestClass.
// 	result context should beKindOf: PMethodContext.
// 	result context homeContext closure selector should be: #initialize.
// 	
// 	result := result origin.
// 	result should beKindOf: PAllocationAlias.
// 	result context should beKindOf: PNativeMethodContext.
// 	result context message selector should be: #basicNew.
// 	result origin should be: nil.
*/
Object symbol7250 = (Object)new_Type_Symbol_cached(L"testInstanceCreation");
// testInstanceCreation. 
Object send41134 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7250, 0);
Eval((Object)send41134);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PAliasInterpreterTest_testFieldOverwriteTest)
/*
testFieldOverwriteTest
// 	| result |
// 	result := PAliasInterpreter interpret: [ |c|
// 		c := ChildClassTestClass new.
// 		c a: 10.
// 		c a: 20.
// 		c
// 	].
// 
// 	result should beKindOf: PReturnAlias.
// 	result value should beKindOf: ChildClassTestClass.
// 	result context should beKindOf: PBlockContext.
// 	result context homeContext closure selector should be: #testFieldOverwriteTest.
// 	
// 	result := result value.
// 	result a should beKindOf: PFieldWriteAlias.
// 	result b should beKindOf: PAllocationAlias.
// 	
// 	result := result a.
// 	result value should be: 20.
// 
// 	result predecessor should beKindOf: PFieldWriteAlias.
// 	result predecessor value should be: 10.
// 	result predecessor predecessor should beKindOf: PAllocationAlias.
// 	result predecessor origin should beKindOf: PParameterAlias.
// 	result predecessor origin value should be: 10.
// 	result predecessor origin origin should beKindOf: PLiteralAlias.
// 	result predecessor origin origin value should be: 10.
// 	result predecessor origin origin origin should be: nil.
// 	
// 	result := result origin.
// 	result should beKindOf: PParameterAlias.
// 	result value should be: 20.
// 	
// 	result := result origin.
// 	result should beKindOf: PLiteralAlias.
// 	result value should be: 20.
// 	result origin should be: nil.
*/
Object symbol7251 = (Object)new_Type_Symbol_cached(L"testFieldOverwriteTest");
// testFieldOverwriteTest. 
Object send41135 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7251, 0);
Eval((Object)send41135);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */


void PAliasInterpreterTest_setUp() {
Object symbol7238 = (Object)new_Type_Symbol_cached(L"setUp");
// setUp. 
Object send41136 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7238, 0);
Eval((Object)send41136);
}

TEST_SUITE(PAliasInterpreterTest,
{
    AutoGenTest_TestCase_Class =(Type_Class)PAliasInterpreterTest;
    AutoGenTest_test_Class_Instance =(Object)new_AST_Constant((Object)instantiate((Type_Class)AutoGenTest_TestCase_Class));

    PAliasInterpreterTest_setUp();
    RUN_TEST(PAliasInterpreterTest_testConstant);
    PAliasInterpreterTest_setUp();
    RUN_TEST(PAliasInterpreterTest_testFieldWriteTest);
    PAliasInterpreterTest_setUp();
    RUN_TEST(PAliasInterpreterTest_testInstanceCreation);
    PAliasInterpreterTest_setUp();
    RUN_TEST(PAliasInterpreterTest_testFieldOverwriteTest);
})