#include <test/lib/test/PInterpreterTest.h>

// Auto generated Tests from PInterpreterTest

// Test Object to put test methods into 
Type_Class AutoGenTest_TestCase_Class;
Object AutoGenTest_test_Class_Instance;
// Test Method symbol 
Type_Symbol PInterpreterTest_SMB_runTestCase;


/* ========================================================================= */

NEW_TEST(PInterpreterTest_testConstant)
/*
testConstant
// 	| exp result |
// 	exp := PConstant new: 2.
// 	result := exp accept: i.
// 	result should = 2
*/
Object symbol7240 = (Object)new_Type_Symbol_cached(L"testConstant");
// testConstant. 
Object send41148 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7240, 0);
Eval((Object)send41148);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testSuper)
/*
testSuper
// 	| exp result |
// 	exp := PSend new: 0.
// 	exp message: #testSuper.
// 	exp receiver: (PConstant new: ChildClassTestClass new).
// 	result := exp accept: i.
// 	result should = 100.	" Check a second time to test if the inline cache doens't break it "
// 	result := exp accept: i.
// 	result should = 100
*/
Object symbol7253 = (Object)new_Type_Symbol_cached(L"testSuper");
// testSuper. 
Object send41149 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7253, 0);
Eval((Object)send41149);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testClosure)
/*
testClosure
// 	| exp result closure |
// 	i context: PMethodContext new.
// 	exp := (PBlock new: 1) params: Array new locals: Array new.
// 	exp at: 1 put: (PConstant new: 42).
// 	closure := exp accept: i.
// 	exp := PSend new: 0.
// 	exp receiver: (PConstant new: closure).
// 	exp message: #value.
// 	result := exp accept: i.
// 	result should = 42
*/
Object symbol7254 = (Object)new_Type_Symbol_cached(L"testClosure");
// testClosure. 
Object send41150 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7254, 0);
Eval((Object)send41150);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testVariableAssign)
/*
testVariableAssign
// 	| exp result closure |
// 	i context: (PMethodContext new: 1).
// 	exp := (PAssign new)
// 		variable: (PVariable localId: 0 scopeId: 0);
// 		expression: (PConstant new: 42).
// 	result := exp accept: i.
// 	result should = 42.
// 	(i context at: 1) should = 42.
// 	i context: (PBlockContext new: 2).
// 	i context outerScope: (PMethodContext new: 1).
// 	exp := (PAssign new)
// 		variable: (PVariable localId: 0 scopeId: 1);
// 		expression: (PConstant new: 43).
// 	result := exp accept: i.
// 	result should = 43.
// 	(i context at: 1) should = 43.
// 	exp := (PAssign new)
// 		variable: (PVariable localId: 0 scopeId: 0);
// 		expression: (PConstant new: 44).
// 	result := exp accept: i.
// 	result should = 44.
// 	(i context at: 1) should = 43.
// 	(i context outerScope at: 1) should = 44
*/
Object symbol7255 = (Object)new_Type_Symbol_cached(L"testVariableAssign");
// testVariableAssign. 
Object send41151 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7255, 0);
Eval((Object)send41151);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testInstVariable)
/*
testInstVariable
// 	| exp result closure |
// 	i context: (PMethodContext new: 1).
// 	i context receiver: ChildClassTestClass new.
// 	i context receiver a: 42.
// 	exp := PInstVariable new index: 0.
// 	result := exp accept: i.
// 	result should = 42.
// 	i context receiver b: 43.
// 	exp := PInstVariable new index: 1.
// 	result := exp accept: i.
// 	result should = 43.
// 	i context: (PBlockContext new: 2).
// 	i context homeContext: (PMethodContext new: 1).
// 	i context homeContext receiver: ChildClassTestClass new.
// 	i context homeContext receiver a: 44.
// 	exp := PInstVariable new index: 0.
// 	result := exp accept: i.
// 	result should = 44
*/
Object symbol7257 = (Object)new_Type_Symbol_cached(L"testInstVariable");
// testInstVariable. 
Object send41152 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7257, 0);
Eval((Object)send41152);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testVariable)
/*
testVariable
// 	| exp result closure |
// 	i context: (PMethodContext new: 1).
// 	i context at: 1 put: 42.
// 	exp := PVariable localId: 0 scopeId: 0.
// 	result := exp accept: i.
// 	result should = 42.
// 	i context: (PBlockContext new: 2).
// 	i context outerScope: (PMethodContext new: 1).
// 	i context at: 1 put: 43.
// 	i context outerScope at: 1 put: 44.
// 	exp := PVariable localId: 0 scopeId: 1.
// 	result := exp accept: i.
// 	result should = 43.
// 	exp := PVariable localId: 0 scopeId: 0.
// 	result := exp accept: i.
// 	result should = 44
*/
Object symbol7259 = (Object)new_Type_Symbol_cached(L"testVariable");
// testVariable. 
Object send41153 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7259, 0);
Eval((Object)send41153);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testSend)
/*
testSend
// 	| exp result |
// 	exp := PSend new: 1.
// 	exp message: #+.
// 	exp receiver: (PConstant new: 2).
// 	exp at: 1 put: (PConstant new: 3).
// 	result := exp accept: i.
// 	result should = 5.	" Check a second time to test if the inline cache doens't break it "
// 	result := exp accept: i.
// 	result should = 5
*/
Object symbol7260 = (Object)new_Type_Symbol_cached(L"testSend");
// testSend. 
Object send41154 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7260, 0);
Eval((Object)send41154);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testReturn)
/*
testReturn
// 	| exp result |
// 	exp := PSend new: 0.
// 	exp message: #returnTest.
// 	exp receiver: (PConstant new: self).
// 	result := exp accept: i.
// 	result should = 10.	" Check a second time to test if the inline cache doens't break it "
// 	result := exp accept: i.
// 	result should = 10
*/
Object symbol7262 = (Object)new_Type_Symbol_cached(L"testReturn");
// testReturn. 
Object send41155 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7262, 0);
Eval((Object)send41155);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testClassReference)
/*
testClassReference
// 	| exp result |
// 	exp := PClassReference named: 'test'.
// 	exp ensurePinocchioClass: ChildClassTestClass.
// 	result := exp accept: i.
// 	result should = ChildClassTestClass
*/
Object symbol7263 = (Object)new_Type_Symbol_cached(L"testClassReference");
// testClassReference. 
Object send41156 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7263, 0);
Eval((Object)send41156);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testInstVariableAssign)
/*
testInstVariableAssign
// 	| exp result closure |
// 	i context: (PMethodContext new: 1).
// 	i context receiver: ChildClassTestClass new.
// 	exp := (PAssign new)
// 		variable: (PInstVariable new index: 0);
// 		expression: (PConstant new: 42).
// 	result := exp accept: i.
// 	result should = 42.
// 	i currentSelf a should = 42.
// 	exp := (PAssign new)
// 		variable: (PInstVariable new index: 1);
// 		expression: (PConstant new: 43).
// 	result := exp accept: i.
// 	result should = 43.
// 	i currentSelf a should = 42.
// 	i currentSelf b should = 43.
// 	i context: (PBlockContext new: 2).
// 	i context homeContext: (PMethodContext new: 1).
// 	i context homeContext receiver: ChildClassTestClass new.
// 	exp := (PAssign new)
// 		variable: (PInstVariable new index: 0);
// 		expression: (PConstant new: 44).
// 	result := exp accept: i.
// 	result should = 44.
// 	i currentSelf a should = 44
*/
Object symbol7265 = (Object)new_Type_Symbol_cached(L"testInstVariableAssign");
// testInstVariableAssign. 
Object send41157 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7265, 0);
Eval((Object)send41157);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testMetaMetaInterpretation)
/*
testMetaMetaInterpretation
// 	| mci send messages |
// 	mci := PTestInterpreter new.
// 	send := PSend new: 0.
// 	send receiver: (PConstant new: self).
// 	messages := (OrderedCollection new)
// 		add: #testClassReference;
// 		add: #testClosure;
// 		add: #testInstVariable;
// 		add: #testInstVariableAssign;
// 		add: #testReturn;
// 		add: #testSelf;
// 		add: #testSend;
// 		add: #testSuper;
// 		add: #testVariable;
// 		add: #testVariableAssign;
// 		yourself.
// 	messages
// 		do:
// 			[ :msg | 
// 			send inlineCache flush.
// 			send message: msg.
// 			send accept: mci ]
*/
Object symbol7266 = (Object)new_Type_Symbol_cached(L"testMetaMetaInterpretation");
// testMetaMetaInterpretation. 
Object send41158 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7266, 0);
Eval((Object)send41158);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PInterpreterTest_testSelf)
/*
testSelf
// 	| object exp result |
// 	object := ChildClassTestClass new.
// 	i context: (PBlockContext new: 1).
// 	i context homeContext: (PMethodContext new: 1).
// 	i context homeContext receiver: object.
// 	exp := PSelf new.
// 	result := exp accept: i.
// 	result should = object
*/
Object symbol7267 = (Object)new_Type_Symbol_cached(L"testSelf");
// testSelf. 
Object send41159 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7267, 0);
Eval((Object)send41159);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */


void PInterpreterTest_setUp() {
Object symbol7238 = (Object)new_Type_Symbol_cached(L"setUp");
// setUp. 
Object send41160 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7238, 0);
Eval((Object)send41160);
}

TEST_SUITE(PInterpreterTest,
{
    AutoGenTest_TestCase_Class =(Type_Class)PInterpreterTest;
    AutoGenTest_test_Class_Instance =(Object)new_AST_Constant((Object)instantiate((Type_Class)AutoGenTest_TestCase_Class));

    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testConstant);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testSuper);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testClosure);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testVariableAssign);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testInstVariable);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testVariable);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testSend);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testReturn);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testClassReference);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testInstVariableAssign);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testMetaMetaInterpretation);
    PInterpreterTest_setUp();
    RUN_TEST(PInterpreterTest_testSelf);
})